Summary:        Real-time software synthesizer
Name:           zynaddsubfx
Version:        2.4.0
Release:        2%{?dist}
License:        GPLv2+
Group:          Applications/Multimedia
URL:            http://zynaddsubfx.sourceforge.net
Source0:        http://download.sf.net/sourceforge/zynaddsubfx/ZynAddSubFX-%{version}.tar.bz2
Source1:        zynaddsubfx.desktop
Patch0:         zynaddsubfx-jack-support.patch
Patch1:         zynaddsubfx-fltk-config-broken.patch
Patch2:         zynaddsubfx-fltk-config-broken-2.patch
Patch3:         zynaddsubfx-build-flags.patch
# Fixed error that prevented XMLwrapper from loading files on Fedora
# http://sourceforge.net/support/tracker.php?aid=2852148
# Also RHBZ #518755
Patch4:         zynaddsubfx-096a2a2db9bc7d7f9bb2bf8ee12136134708ef23.patch
Patch5:         zynaddsubfx-5bf008e390b86944b8175c21f2a021a4d6863de2.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       fltk >= 1.1.3
Requires:       jack-audio-connection-kit >= 0.101.1
Requires:       mxml >= 2.2
Requires:       hicolor-icon-theme

BuildRequires:  alsa-lib-devel fftw3-devel fltk-devel mxml-devel
BuildRequires:  jack-audio-connection-kit-devel zlib-devel lash-devel
BuildRequires:  libX11-devel fltk-fluid
BuildRequires:  ImageMagick

#dssi support is broken for now
#BuildRequires:  dssi-devel
BuildRequires:  desktop-file-utils

%description
ZynAddSubFX is an open source software synthesizer capable of making a
countless number of instrument sounds. It is microtonal, and the instruments
made by it sounds like those from professional keyboards. The program has
effects like Reverb, Echo, Chorus, Phaser...

%prep
%setup -q -n ZynAddSubFX-%{version}
%patch0 -p1 -b .jack
%patch1 -p0 -b .fltk1
%patch2 -p1 -b .fltk2
%patch3 -p1 -b .flags
%patch4 -p1 -b .doxy
%patch5 -p1 -b .loadfiles

%build
%ifarch %{ix86} x86_64 
# We're ok.
%else
sed -i -e "s|ASM_F2I=YES|ASM_F2I=NO|g" src/Makefile.inc
%endif

cd src
# do not use smp flags, makefile is not smp safe
make

# build external programs
cd ../ExternalPrograms
cd Controller
make
cd ../Spliter
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}

tar cf - examples banks presets | \
(cd $RPM_BUILD_ROOT%{_datadir}/%{name}; tar xvpf -)
cd src
install -m 0755 zynaddsubfx $RPM_BUILD_ROOT%{_bindir}

# install external programs
cd ../ExternalPrograms
cd Controller
install -m 0755 zynaddsubfx-controller $RPM_BUILD_ROOT%{_bindir}/controller
cd ../Spliter
install -m 0755 zynaddsubfx-spliter $RPM_BUILD_ROOT%{_bindir}/spliter
cd ../..

# .desktop file
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor fedora \
   --dir=$RPM_BUILD_ROOT%{_datadir}/applications %{SOURCE1}


mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/64x64/apps
convert -resize 16x16 zynaddsubfx_icon.ico zynaddsubfx-16.png
convert -resize 32x32 zynaddsubfx_icon.ico zynaddsubfx-32.png
convert -resize 48x48 zynaddsubfx_icon.ico zynaddsubfx-48.png
convert -resize 64x64 zynaddsubfx_icon.ico zynaddsubfx-64.png
install -m 644 zynaddsubfx-32.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/zynaddsubfx.png
install -m 644 zynaddsubfx-16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/zynaddsubfx.png
install -m 644 zynaddsubfx-32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/zynaddsubfx.png
install -m 644 zynaddsubfx-48.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/zynaddsubfx.png
install -m 644 zynaddsubfx-64.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/64x64/apps/zynaddsubfx.png

%clean
rm -rf $RPM_BUILD_ROOT

%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files
%defattr(-,root,root,-)
%doc AUTHORS.txt ChangeLog COPYING FAQ.txt HISTORY.txt README.txt bugs.txt
%{_bindir}/*
%{_datadir}/%{name}
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/pixmaps/zynaddsubfx.png
%{_datadir}/icons/hicolor/16x16/apps/zynaddsubfx.png
%{_datadir}/icons/hicolor/32x32/apps/zynaddsubfx.png
%{_datadir}/icons/hicolor/48x48/apps/zynaddsubfx.png
%{_datadir}/icons/hicolor/64x64/apps/zynaddsubfx.png

%changelog
* Tue Sep 08 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 2.4.0-2
- Bugfix: presets and parameters don't load on ix86 (RHBZ #518755)

* Thu Aug 06 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 2.4.0-1
- Update to 2.4.0
- Update scriptlets according to new guidelines
- Update the .desktop file
- Use Fedora specific flags during compilation
- License is GPLv2+ (just run the program on the command line :))

* Mon Jul 27 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.1-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.1-20
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Aug 11 2008 Jason L Tibbitts III <tibbs@math.uh.edu> - 2.2.1-19
- Fix license tag.

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 2.2.1-18
- Autorebuild for GCC 4.3

* Wed Oct 10 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.1-17
- added tweaked unzombify patch by Lars Luthman (patch3), see:
  http://sourceforge.net/tracker/index.php?func=detail&aid=1498438&group_id=62934&atid=502314

* Tue Oct 09 2007 Anthony Green <green@redhat.com> 2.2.1-16
- Rebuilt for new lash again.

* Mon Oct 08 2007 Anthony Green <green@redhat.com> 2.2.1-15
- Rebuilt for new lash.

* Wed Mar 14 2007 Anthony Green <green@redhat.com> 2.2.1-14
- Rebuild with new ImageMagick for working desktop icons.

* Thu Oct 05 2006 Christian Iseli <Christian.Iseli@licr.org> 2.2.1-13
 - rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Tue Sep 19 2006 Anthony Green <green@redhat.com>  2.2.1-12
- Fix release tag.

* Mon Sep 18 2006 Anthony Green <green@redhat.com>  2.2.1-11.1
- Rebuild.

* Wed Aug 30 2006 Anthony Green <green@redhat.com>  2.2.1-11
- Fix ppc problem (in a different way).

* Wed Aug 30 2006 Anthony Green <green@redhat.com>  2.2.1-10
- Fix ppc problem.  Add perl dependency.

* Wed Aug 30 2006 Anthony Green <green@redhat.com>  2.2.1-9
- Only build for x86 and x86-64 for now.  (ppc build problem)

* Wed Aug 30 2006 Anthony Green <green@redhat.com>  2.2.1-8
- Depend on hicolor-icon-theme.

* Sat Aug 26 2006 Anthony Green <green@redhat.com>  2.2.1-7
- Add dist tag to release version.
- Tidy up description.
- Use standard scriptlets in %%post/%%postun.

* Thu Jul 20 2006 Anthony Green <green@redhat.com>  2.2.1-6
- Fix compile options and remove rpath usage (bug in fltk-config).

* Sat Jul 15 2006 Anthony Green <green@redhat.com>  2.2.1-5
- First Fedora Extras build.
- Fix Source0 permissions.
- Add desktop-file-utils requirements.
- Tweak macro usage and .desktop file.
- Convert and install icons.  Add post(un) install scripts.
- Add ImageMagick BuildRequires.

* Mon May  8 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.1-4
- added lash patch (http://www.student.nada.kth.se/~d00-llu/programming.php)

* Sat May  6 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.1-3
- add Planet CCRMA categories to desktop file

* Fri Mar 31 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- build on fc5

* Fri Sep 23 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.1-2
- rebuilt with new version of mxml (2.2.2)
- added specific requires for mxml version

* Tue May  3 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.1-1
- updated to 2.2.1

* Fri Apr  8 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.2.0-1
- updated to 2.2.0

* Mon Feb  7 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.1.1-2
- fixed microtuning bug (patch from Paul Nasca)

* Sun Oct  3 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.1.1-1
- updated to 2.1.1

* Fri Oct  1 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.1.0-1
- updated to 2.1.0

* Fri Aug 27 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0.0-1
- updated to 2.0.0 final
- readded examples directory to the file list
- installed banks and presets
- compiled and installed "controller" and "spliter"

* Wed Aug  4 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0.0-0.pre2.1
- updated to latest prerelease
- added mxml build dependency, updated requirements to fftw3
- no documentation or examples for now

* Sat Nov  8 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.4.3-1
- spec file tweaks

* Mon Sep  1 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.4.3-1
- updated to 1.4.3, added release tag

* Fri Jul 25 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.4.2-1
- updated to 1.4.2

* Thu May  8 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.4.1-1
- updated to 1.4.1 (docs are still 1.4.0)

* Tue May  6 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.4.0-1
- updated to 1.4.0

* Tue Apr  8 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2
- rebuilt for newer version of fftw

* Tue Apr  8 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-1
- udpated to 1.2.1

* Wed Apr  2 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.0-2
- rebuild for jack 0.66.3, added explicit requires for it

* Fri Mar 21 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.0-1
- updated to 1.2.0

* Thu Mar  6 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0.9-2
- rebuilt due to changed fltk (from 1.1.0rc3 to 1.1.3)
- commented out deprecated jack_set_buffer_size_callback() call

* Mon Feb 24 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0.9-1
- updated to 1.0.9

* Fri Feb 14 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0.8-1
- updated to 1.0.8

* Fri Feb  6 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0.7-1
- updated to 1.0.7

* Sun Jan 26 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0.5-1
- Initial build.
